// by LordSkelethom
#ifndef GAME_SERVER_HPRACE_SCORE_H
#define GAME_SERVER_HPRACE_SCORE_H

#include <engine/shared/protocol.h>

class HPRACE_TEAM_SCORE
{
public:
	char name[MAX_NAME_LENGTH];
	char name2[MAX_NAME_LENGTH];
	float score;
	char ip[16];
	char ip2[16];

	HPRACE_TEAM_SCORE(const char *name, const char *name2, float score, const char *ip, const char *ip2, int id=-1);
	int get_color();

	bool operator==(const HPRACE_TEAM_SCORE& other) { return (this->score == other.score); }
	bool operator<(const HPRACE_TEAM_SCORE& other) { return (this->score < other.score); }

private:
	int id;
};

class HPRACE_SCORE
{
	class CGameContext *m_pGameServer;
	class IServer *m_pServer;
	CGameContext *GameServer() const { return m_pGameServer; }
	IServer *Server() const { return m_pServer; }

public:
	HPRACE_SCORE();

	void init(class CGameContext *pGameServer);
	void save();
	void load();
	HPRACE_TEAM_SCORE *search_score(int id, bool score_ip, int *position);
	HPRACE_TEAM_SCORE *search_name(const char *name, int *position, bool match_case);
	HPRACE_TEAM_SCORE *search_team(const char *name, const char *name2, int *position);
	void parseTeam(HPRACE_TEAM_SCORE *_team);
	void initTeam(int id, int id2);
	void top5_draw(int id, int debut);
};

#endif
